%define __check_files %{nil}

# CPU optimization
##################
%if 0%{?avx:1}
%define target_processor .avx
%define configure_opts --enable-sse3 --enable-sse4 --enable-avx --with-instruction-set=avx
%else

%if 0%{?sse4:1}
%define target_processor .sse4
%define configure_opts --enable-sse3 --enable-sse4 --disable-avx --with-instruction-set=sse4
%else

%if 0%{?sse3:1}
%define target_processor .sse3
%define configure_opts --enable-sse3 --disable-sse4 --disable-avx --with-instruction-set=sse3
%else
%define configure_opts --disable-sse3 --disable-sse4 --disable-avx --with-instruction-set=sse2
%endif  # sse3

%endif  # sse4

%endif  # avx
##################

Summary: A Java programming language debugging tool.
Name: heapstats_agent
Version: 1.3
%define RELEASE_NUM 2
%define DIST_EXT %{?dist:%{dist}}%{!?dist:.el5}
Release: %{RELEASE_NUM}%{?target_processor:%{target_processor}}%{DIST_EXT}
License: GPLv2
Vendor: NTT OSS Center
Group: Development/Debuggers
Source: heapstats-%{version}.%{RELEASE_NUM}.tar.gz
#Patch0: none
Buildroot: /var/tmp/heapstats

# Requires for running
Requires: pcre >= 6
Requires: net-snmp-libs >= 5.3

# Requires for building
BuildRequires: pcre-devel >= 6
BuildRequires: net-snmp-devel >= 5.3
#BuildRequires: java-1.6.0-openjdk-devel
BuildRequires: /usr/lib/jvm/java-openjdk/bin/javac
BuildRequires: binutils >= 2
BuildRequires: autoconf
BuildRequires: automake
BuildRequires: libtool

%description
this program analyzes running information in JVM.
Copyright (C) 2011-2013 Nippon Telegraph and Telephone Corporation.

%prep
%setup -q -n heapstats-%{version}/agent

%build
CXXFLAGS="$RPM_OPT_FLAGS" ./configure \
  --build=%{_build} \
  --host=%{_host} \
  --target=%{_target_platform} \
  --prefix=%{_prefix} \
  --libdir=%{_libdir}/heapstats \
  --sysconfdir=%{_sysconfdir}/heapstats \
  --disable-vmstructs \
  %{configure_opts} \
  --enable-debug \
  --enable-optimize \
  --without-gcov \
  --disable-profile
make RPM_OPT_FLAGS="$RPM_OPT_FLAGS"

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p ${RPM_BUILD_ROOT}%{_libdir}/heapstats
make install DESTDIR=${RPM_BUILD_ROOT}
mkdir $RPM_BUILD_ROOT/etc/ld.so.conf.d/
echo "%{_libdir}/heapstats" \
  >> $RPM_BUILD_ROOT/etc/ld.so.conf.d/heapstats_agent.conf
mkdir -p $RPM_BUILD_ROOT/usr/share/snmp/mibs/
cp ./mib/HeapStatsMibs.txt $RPM_BUILD_ROOT/usr/share/snmp/mibs/


%post
/sbin/ldconfig

%postun
/sbin/ldconfig

%clean
rm -rf $RPM_BUILD_ROOT

%files
%dir %{_libdir}/heapstats/
%{_libdir}/heapstats/libheapstats*.so*
%doc NEWS README COPYING AUTHORS ChangeLog
%dir %{_sysconfdir}/heapstats/
%config(missingok) %{_sysconfdir}/heapstats/heapstats.conf
%{_sysconfdir}/heapstats/attachjvm.sh
%{_sysconfdir}/heapstats/AgentAttacher.jar
/etc/ld.so.conf.d/heapstats_agent.conf

%changelog
* Fri Jul 19 2013 Yasumasa Suenaga <suenaga.yasumasa@lab.ntt.co.jp> 1.3.2
- Add Java heap alert.
- Add Metaspace / PermGen alert and logging.
- Adapt NPG for Java8.
- Some bug fixes.

* Fri Jul 19 2013 Yasumasa Suenaga <suenaga.yasumasa@lab.ntt.co.jp> 1.3.1
- Performance improvement for HeapStats agent.
- Some bug fixes.

* Tue Mar 19 2013 ShinjiHisano <shinji.hisano@as.ntt-at.co.jp> 1.3-00
- Snapshot file store class reference information too.
- Thereby snapshot file format was changed.
- Heapstats agent show an alert message if raised disk full error.
- Some timer's interval can change by reload configuration.
- Heapstats agent collects information of socket used by java application.
- The "on-demand-attach" program was added.
- The configuration file format was changed.

* Fri Aug 31 2012 ShinjiHisano <shinji.hisano@as.ntt-at.co.jp> 1.2-02
- Change method to getting Java heap object.
- Agent support to reload configuration file.
- Agent do logging on occcurred deadlock.
- Agent try to make zip file by JNI, if making archive has failed by command.
- Agent try to dump thread by JVMTI, if normal thread dump has failed.

* Wed Mar 16 2012 ShinjiHisano <shinji.hisano@as.ntt-at.co.jp> 1.2-01
- Agent do logging about JVM running environments.

* Wed Dec 09 2011 ShinjiHisano <shinji.hisano@as.ntt-at.co.jp> 1.0-00
- Initial Release

